Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4099)
@@ -89,408 +115,308 @@
 
       !--------------------------------------------------------------------
-      ! 2) Ice initialization (hi,hs,frld,t_su,sm_i,t_i,t_s)              | 
-      !--------------------------------------------------------------------
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'lim_istate : Ice initialization '
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
-
+      ! 2) Basal temperature, ice mask and hemispheric index
+      !--------------------------------------------------------------------
+
+      ! Basal temperature is set to the freezing point of seawater in Celsius
       t_bo(:,:) = tfreez( tsn(:,:,1,jp_sal) ) * tmask(:,:,1)       ! freezing/melting point of sea water [Celcius]
 
       DO jj = 1, jpj                                       ! ice if sst <= t-freez + ttest
          DO ji = 1, jpi
-            IF( tsn(ji,jj,1,jp_tem)  - t_bo(ji,jj) >= ttest ) THEN   ;   zidto(ji,jj) = 0.e0      ! no ice
-            ELSE                                                     ;   zidto(ji,jj) = 1.e0      !    ice
+            IF( tsn(ji,jj,1,jp_tem)  - t_bo(ji,jj) >= ttest ) THEN   ;   zidto(ji,jj) = 0._wp      ! no ice
+            ELSE                                                     ;   zidto(ji,jj) = 1._wp      !    ice
             ENDIF
          END DO
       END DO
 
-      t_bo(:,:) = t_bo(:,:) + rt0                          ! t_bo converted from Celsius to Kelvin (rt0 over land)
-
-      ! constants for heat contents
-      zeps   = 1.e-20_wp
-      zeps6  = 1.e-06_wp
-
-      ! zgfactor for initial ice distribution
-      zgfactorn(:) = 0._wp
-      zgfactors(:) = 0._wp
-
-      ! first ice type
-      DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2)
-         zhin (1)     = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
-         zgfactorn(1) = zgfactorn(1) + exp(-(zhin(1)-hginn_u)*(zhin(1)-hginn_u) * 0.5_wp )
-         zhis (1)     = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
-         zgfactors(1) = zgfactors(1) + exp(-(zhis(1)-hgins_u)*(zhis(1)-hgins_u) * 0.5_wp )
-      END DO ! jl
-      zgfactorn(1) = aginn_u / zgfactorn(1)
-      zgfactors(1) = agins_u / zgfactors(1)
-
-      ! -------------
-      ! new distribution, polynom of second order, conserving area and volume
-      zh1 = 0._wp
-      zh2 = 0._wp
-      zh3 = 0._wp
-      DO jl = 1, jpl
-         zh = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
-         zh1 = zh1 + zh
-         zh2 = zh2 + zh * zh
-         zh3 = zh3 + zh * zh * zh
-      END DO
-      IF(lwp) WRITE(numout,*) ' zh1 : ', zh1
-      IF(lwp) WRITE(numout,*) ' zh2 : ', zh2
-      IF(lwp) WRITE(numout,*) ' zh3 : ', zh3
-
-      zvol = aginn_u * hginn_u
-      zare = aginn_u
-      IF( jpl >= 2 ) THEN
-         zbn = ( zvol*zh2 - zare*zh3 ) / ( zh2*zh2 - zh1*zh3)
-         zan = ( zare - zbn*zh1 ) / zh2
-      ENDIF
-
-      IF(lwp) WRITE(numout,*) ' zvol: ', zvol
-      IF(lwp) WRITE(numout,*) ' zare: ', zare
-      IF(lwp) WRITE(numout,*) ' zbn : ', zbn 
-      IF(lwp) WRITE(numout,*) ' zan : ', zan 
-
-      zvol = agins_u * hgins_u
-      zare = agins_u
-      IF( jpl >= 2 ) THEN
-         zbs = ( zvol*zh2 - zare*zh3 ) / ( zh2*zh2 - zh1*zh3)
-         zas = ( zare - zbs*zh1 ) / zh2
-      ENDIF
-
-      IF(lwp) WRITE(numout,*) ' zvol: ', zvol
-      IF(lwp) WRITE(numout,*) ' zare: ', zare
-      IF(lwp) WRITE(numout,*) ' zbn : ', zbn 
-      IF(lwp) WRITE(numout,*) ' zan : ', zan 
-
-      !end of new lines
-      ! -------------
-!!!
-      ! retour a LIMA_MEC
-      !     ! second ice type
-      !     zdummy  = hi_max(ice_cat_bounds(2,1)-1)
-      !     hi_max(ice_cat_bounds(2,1)-1) = 0.0
-
-      !     ! here to change !!!!
-      !     jm = 2
-      !     DO jl = ice_cat_bounds(jm,1), ice_cat_bounds(jm,2)
-      !        zhin (2)     = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-      !        zhin (2)     = ( hi_max_typ(jl-ice_cat_bounds(2,1),jm    ) + &
-      !                         hi_max_typ(jl-ice_cat_bounds(2,1) + 1,jm)   ) / 2.0
-      !        zgfactorn(2) = zgfactorn(2) + exp(-(zhin(2)-hginn_d)*(zhin(2)-hginn_d)/2.0)
-      !        zhis (2)     = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-      !        zhis (2)     = ( hi_max_typ(jl-ice_cat_bounds(2,1),jm    ) + &
-      !                         hi_max_typ(jl-ice_cat_bounds(2,1) + 1,jm)   ) / 2.0
-      !        zgfactors(2) = zgfactors(2) + exp(-(zhis(2)-hgins_d)*(zhis(2)-hgins_d)/2.0)
-      !     END DO ! jl
-      !     zgfactorn(2) = aginn_d / zgfactorn(2)
-      !     zgfactors(2) = agins_d / zgfactors(2)
-      !     hi_max(ice_cat_bounds(2,1)-1) = zdummy
-      ! END retour a LIMA_MEC
-!!!
-
-!!gm  optimisation :  loop over the ice categories inside the ji, jj loop !!!
-
+      t_bo(:,:) = t_bo(:,:) + rt0                          ! conversion to Kelvin
+
+      ! Hemispheric index
+      ! MV 2011 new initialization
       DO jj = 1, jpj
          DO ji = 1, jpi
-
-            !--- Northern hemisphere
-            !----------------------------------------------------------------
             IF( fcor(ji,jj) >= 0._wp ) THEN    
-
-               !-----------------------
-               ! Ice area / thickness
-               !-----------------------
-
-               IF ( jpl .EQ. 1) THEN ! one category
-
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) ! loop over ice thickness categories
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * aginn_u
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * hginn_u
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-                  END DO
-
-               ELSE ! several categories
-
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) ! loop over ice thickness categories
-                     zhin(1)          = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * MAX( zgfactorn(1) * exp(-(zhin(1)-hginn_u)* & 
-                        (zhin(1)-hginn_u)/2.0) , epsi06)
-                     ! new line
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * ( zan * zhin(1) * zhin(1) + zbn * zhin(1) )
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * zhin(1) 
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-                  END DO
-
-               ENDIF
-
-
-!!!
-               ! retour a LIMA_MEC
-               !              !ridged ice
-               !              zdummy  = hi_max(ice_cat_bounds(2,1)-1)
-               !              hi_max(ice_cat_bounds(2,1)-1) = 0.0
-               !              DO jl = ice_cat_bounds(2,1), ice_cat_bounds(2,2) ! loop over ice thickness categories
-               !                 zhin(2)          = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-               !                 a_i(ji,jj,jl)    = zidto(ji,jj) * MAX( zgfactorn(2) * exp(-(zhin(2)-hginn_d)* &
-               !                                    (zhin(2)-hginn_d)/2.0) , epsi06)
-               !                 ht_i(ji,jj,jl)   = zidto(ji,jj) * zhin(2) 
-               !                 v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-               !              END DO
-               !              hi_max(ice_cat_bounds(2,1)-1) = zdummy
-
-               !              !rafted ice
-               !              jl = 6
-               !              a_i(ji,jj,jl)       = 0.0
-               !              ht_i(ji,jj,jl)      = 0.0
-               !              v_i(ji,jj,jl)       = 0.0
-               ! END retour a LIMA_MEC
-!!!
-
-               DO jl = 1, jpl
-
-                  !-------------
-                  ! Snow depth
-                  !-------------
-                  ht_s(ji,jj,jl)   = zidto(ji,jj) * hninn
-                  v_s(ji,jj,jl)    = ht_s(ji,jj,jl)*a_i(ji,jj,jl)
-
-                  !---------------
-                  ! Ice salinity
-                  !---------------
-                  sm_i(ji,jj,jl)   = zidto(ji,jj) * sinn  + ( 1.0 - zidto(ji,jj) ) * 0.1
-                  smv_i(ji,jj,jl)  = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl)
-
-                  !----------
-                  ! Ice age
-                  !----------
-                  o_i(ji,jj,jl)    = zidto(ji,jj) * 1.0   + ( 1.0 - zidto(ji,jj) )
-                  oa_i(ji,jj,jl)   = o_i(ji,jj,jl) * a_i(ji,jj,jl)
-
-                  !------------------------------
-                  ! Sea ice surface temperature
-                  !------------------------------
-
-                  t_su(ji,jj,jl)   = zidto(ji,jj) * 270.0 + ( 1.0 - zidto(ji,jj) ) * t_bo(ji,jj)
-
-                  !------------------------------------
-                  ! Snow temperature and heat content
-                  !------------------------------------
-
-                  DO jk = 1, nlay_s
-                     t_s(ji,jj,jk,jl) = zidto(ji,jj) * 270.00 + ( 1.0 - zidto(ji,jj) ) * rtt
-                     ! Snow energy of melting
-                     e_s(ji,jj,jk,jl) = zidto(ji,jj) * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
-                     ! Change dimensions
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
-                     ! Multiply by volume, so that heat content in 10^9 Joules
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * &
-                        v_s(ji,jj,jl)  / nlay_s
-                  END DO !jk
-
-                  !-----------------------------------------------
-                  ! Ice salinities, temperature and heat content 
-                  !-----------------------------------------------
-
-                  DO jk = 1, nlay_i
-                     t_i(ji,jj,jk,jl) = zidto(ji,jj)*270.00 + ( 1.0 - zidto(ji,jj) ) * rtt 
-                     s_i(ji,jj,jk,jl) = zidto(ji,jj) * sinn + ( 1.0 - zidto(ji,jj) ) * 0.1
-                     ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
-
-                     ! heat content per unit volume
-                     e_i(ji,jj,jk,jl) = zidto(ji,jj) * rhoic * &
-                        (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
-                        +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-zeps) ) &
-                        - rcp      * ( ztmelts - rtt ) &
-                        )
-
-                     ! Correct dimensions to avoid big values
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
-
-                     ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * & 
-                        area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / &
-                        nlay_i
-                  END DO ! jk
-
-               END DO ! jl 
-
-            ELSE ! on fcor 
-
-               !--- Southern hemisphere
-               !----------------------------------------------------------------
-
-               !-----------------------
-               ! Ice area / thickness
-               !-----------------------
-
-               IF ( jpl .EQ. 1) THEN ! one category
-
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) ! loop over ice thickness categories
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * agins_u
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * hgins_u
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-                  END DO
-
-               ELSE ! several categories
-
-                  !level ice
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) !over thickness categories
-
-                     zhis(1)       = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-                     a_i(ji,jj,jl) = zidto(ji,jj) * MAX( zgfactors(1) * exp(-(zhis(1)-hgins_u) * & 
-                        (zhis(1)-hgins_u)/2.0) , epsi06 )
-                     ! new line square distribution volume conserving
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * ( zas * zhis(1) * zhis(1) + zbs * zhis(1) )
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * zhis(1) 
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-
-                  END DO ! jl
-
-               ENDIF
-
-!!!
-               ! retour a LIMA_MEC
-               !              !ridged ice
-               !              zdummy  = hi_max(ice_cat_bounds(2,1)-1)
-               !              hi_max(ice_cat_bounds(2,1)-1) = 0.0
-               !              DO jl = ice_cat_bounds(2,1), ice_cat_bounds(2,2) !over thickness categories
-               !                 zhis(2)       = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-               !                 a_i(ji,jj,jl) = zidto(ji,jj)*MAX( zgfactors(2)   &
-               !                    &          * exp(-(zhis(2)-hgins_d)*(zhis(2)-hgins_d)/2.0), epsi06 )
-               !                 ht_i(ji,jj,jl)   = zidto(ji,jj) * zhis(2) 
-               !                 v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-               !              END DO
-               !              hi_max(ice_cat_bounds(2,1)-1) = zdummy
-
-               !              !rafted ice
-               !              jl = 6
-               !              a_i(ji,jj,jl)       = 0.0
-               !              ht_i(ji,jj,jl)      = 0.0
-               !              v_i(ji,jj,jl)       = 0.0
-               ! END retour a LIMA_MEC
-!!!
-
-               DO jl = 1, jpl !over thickness categories
-
-                  !---------------
-                  ! Snow depth
-                  !---------------
-
-                  ht_s(ji,jj,jl)   = zidto(ji,jj) * hnins
-                  v_s(ji,jj,jl)    = ht_s(ji,jj,jl)*a_i(ji,jj,jl)
-
-                  !---------------
-                  ! Ice salinity
-                  !---------------
-
-                  sm_i(ji,jj,jl)   = zidto(ji,jj) * sins  + ( 1.0 - zidto(ji,jj) ) * 0.1
-                  smv_i(ji,jj,jl)  = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl)
-
-                  !----------
-                  ! Ice age
-                  !----------
-
-                  o_i(ji,jj,jl)    = zidto(ji,jj) * 1.0   + ( 1.0 - zidto(ji,jj) )
-                  oa_i(ji,jj,jl)   = o_i(ji,jj,jl) * a_i(ji,jj,jl)
-
-                  !------------------------------
-                  ! Sea ice surface temperature
-                  !------------------------------
-
-                  t_su(ji,jj,jl)   = zidto(ji,jj) * 270.0 + ( 1.0 - zidto(ji,jj) ) * t_bo(ji,jj)
-
-                  !----------------------------------
-                  ! Snow temperature / heat content
-                  !----------------------------------
-
-                  DO jk = 1, nlay_s
-                     t_s(ji,jj,jk,jl) = zidto(ji,jj) * 270.00 + ( 1.0 - zidto(ji,jj) ) * rtt
-                     ! Snow energy of melting
-                     e_s(ji,jj,jk,jl) = zidto(ji,jj) * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
-                     ! Change dimensions
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
-                     ! Multiply by volume, so that heat content in 10^9 Joules
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * &
-                        v_s(ji,jj,jl)  / nlay_s
-                  END DO
-
-                  !---------------------------------------------
-                  ! Ice temperature, salinity and heat content
-                  !---------------------------------------------
-
-                  DO jk = 1, nlay_i
-                     t_i(ji,jj,jk,jl) = zidto(ji,jj)*270.00 + ( 1.0 - zidto(ji,jj) ) * rtt 
-                     s_i(ji,jj,jk,jl) = zidto(ji,jj) * sins + ( 1.0 - zidto(ji,jj) ) * 0.1
-                     ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
-
-                     ! heat content per unit volume
-                     e_i(ji,jj,jk,jl) = zidto(ji,jj) * rhoic * &
-                        (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
-                        +   lfus  * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-zeps) ) &
-                        - rcp      * ( ztmelts - rtt ) &
-                        )
-
-                     ! Correct dimensions to avoid big values
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
-
-                     ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * & 
-                        area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / &
-                        nlay_i
-                  END DO !jk
-
-               END DO ! jl 
-
-            ENDIF ! on fcor
-
+               zhemis(ji,jj) = 1 ! Northern hemisphere
+            ELSE
+               zhemis(ji,jj) = 2 ! Southern hemisphere
+            ENDIF
          END DO
       END DO
-
-      !--------------------------------------------------------------------
-      ! 3) Global ice variables for output diagnostics                    | 
-      !--------------------------------------------------------------------
-
-      fsbbq (:,:)     = 0.e0
-      u_ice (:,:)     = 0.e0
-      v_ice (:,:)     = 0.e0
-      stress1_i(:,:)  = 0.0
-      stress2_i(:,:)  = 0.0
-      stress12_i(:,:) = 0.0
-
-      !--------------------------------------------------------------------
-      ! 4) Moments for advection
-      !--------------------------------------------------------------------
-
-      sxopw (:,:) = 0.e0 
-      syopw (:,:) = 0.e0 
-      sxxopw(:,:) = 0.e0 
-      syyopw(:,:) = 0.e0 
-      sxyopw(:,:) = 0.e0
-
-      sxice (:,:,:)  = 0.e0   ;   sxsn (:,:,:)  = 0.e0   ;   sxa  (:,:,:)  = 0.e0
-      syice (:,:,:)  = 0.e0   ;   sysn (:,:,:)  = 0.e0   ;   sya  (:,:,:)  = 0.e0
-      sxxice(:,:,:)  = 0.e0   ;   sxxsn(:,:,:)  = 0.e0   ;   sxxa (:,:,:)  = 0.e0
-      syyice(:,:,:)  = 0.e0   ;   syysn(:,:,:)  = 0.e0   ;   syya (:,:,:)  = 0.e0
-      sxyice(:,:,:)  = 0.e0   ;   sxysn(:,:,:)  = 0.e0   ;   sxya (:,:,:)  = 0.e0
-
-      sxc0  (:,:,:)  = 0.e0   ;   sxe  (:,:,:,:)= 0.e0   
-      syc0  (:,:,:)  = 0.e0   ;   sye  (:,:,:,:)= 0.e0   
-      sxxc0 (:,:,:)  = 0.e0   ;   sxxe (:,:,:,:)= 0.e0   
-      syyc0 (:,:,:)  = 0.e0   ;   syye (:,:,:,:)= 0.e0   
-      sxyc0 (:,:,:)  = 0.e0   ;   sxye (:,:,:,:)= 0.e0   
-
-      sxsal  (:,:,:)  = 0.e0
-      sysal  (:,:,:)  = 0.e0
-      sxxsal (:,:,:)  = 0.e0
-      syysal (:,:,:)  = 0.e0
-      sxysal (:,:,:)  = 0.e0
-
-      !--------------------------------------------------------------------
-      ! 5) Lateral boundary conditions                                    | 
+      ! END MV 2011 new initialization
+
+      !--------------------------------------------------------------------
+      ! 3) Initialization of sea ice state variables
+      !--------------------------------------------------------------------
+
+      !-----------------------------
+      ! 3.1) Hemisphere-dependent arrays
+      !-----------------------------
+      ! assign initial thickness, concentration, snow depth and salinity to
+      ! an hemisphere-dependent array
+      zhm_i_ini(1) = hginn ; zhm_i_ini(2) = hgins  ! ice thickness
+      zat_i_ini(1) = aginn ; zat_i_ini(2) = agins  ! ice concentration
+      zvt_i_ini(:) = zhm_i_ini(:) * zat_i_ini(:)   ! ice volume
+      zhm_s_ini(1) = hninn ; zhm_s_ini(2) = hnins  ! snow depth
+      zsm_i_ini(1) = sinn  ; zsm_i_ini(2) = sins   ! bulk ice salinity
+
+      !---------------------------------------------------------------------
+      ! 3.2) Distribute ice concentration and thickness into the categories
+      !---------------------------------------------------------------------
+      ! a gaussian distribution for ice concentration is used
+      ! then we check whether the distribution fullfills
+      ! volume and area conservation, positivity and ice categories bounds
+      DO i_hemis = 1, 2
+
+      ztest_1 = 0 ; ztest_2 = 0 ; ztest_3 = 0 ; ztest_4 = 0
+
+      ! note for the great nemo engineers: 
+      ! only very few of the WRITE statements are necessary for the reference version
+      ! they were one day useful, but now i personally doubt of their
+      ! potential for bringing anything useful
+
+      DO i_fill = jpl, 1, -1
+         IF ( ( ztest_1 + ztest_2 + ztest_3 + ztest_4 ) .NE. 4 ) THEN
+            !----------------------------
+            ! fill the i_fill categories
+            !----------------------------
+            ! *** 1 category to fill
+            IF ( i_fill .EQ. 1 ) THEN
+               zht_i_ini(1,i_hemis)       = zhm_i_ini(i_hemis)
+               za_i_ini(1,i_hemis)        = zat_i_ini(i_hemis)
+               zht_i_ini(2:jpl,i_hemis)   = 0._wp
+               za_i_ini(2:jpl,i_hemis)    = 0._wp
+            ELSE
+
+            ! *** >1 categores to fill
+            !--- Ice thicknesses in the i_fill - 1 first categories
+               DO jl = 1, i_fill - 1
+                  zht_i_ini(jl,i_hemis)    = 0.5 * ( hi_max(jl) + hi_max(jl-1) )
+               END DO
+
+            !--- jl0: most likely index where cc will be maximum
+               DO jl = 1, jpl
+                  IF ( ( zhm_i_ini(i_hemis) .GT. hi_max(jl-1) ) .AND. &
+                       ( zhm_i_ini(i_hemis) .LE. hi_max(jl)   ) ) THEN
+                     jl0 = jl
+                  ENDIF
+               END DO
+               jl0 = MIN(jl0, i_fill)
+
+            !--- Concentrations
+               za_i_ini(jl0,i_hemis)      = zat_i_ini(i_hemis) / SQRT(REAL(jpl))
+               DO jl = 1, i_fill - 1
+                  IF ( jl .NE. jl0 ) THEN
+                     zsigma               = 0.5 * zhm_i_ini(i_hemis)
+                     zarg                 = ( zht_i_ini(jl,i_hemis) - zhm_i_ini(i_hemis) ) / zsigma
+                     za_i_ini(jl,i_hemis) = za_i_ini(jl0,i_hemis) * EXP(-zarg**2)
+                  ENDIF
+               END DO 
+
+               zA = 0. ! sum of the areas in the jpl categories 
+               DO jl = 1, i_fill - 1
+                 zA = zA + za_i_ini(jl,i_hemis)
+               END DO
+               za_i_ini(i_fill,i_hemis)   = zat_i_ini(i_hemis) - zA ! ice conc in the last category
+               IF ( i_fill .LT. jpl ) za_i_ini(i_fill+1:jpl, i_hemis) = 0._wp
+         
+            !--- Ice thickness in the last category
+               zV = 0. ! sum of the volumes of the N-1 categories
+               DO jl = 1, i_fill - 1
+                  zV = zV + za_i_ini(jl,i_hemis)*zht_i_ini(jl,i_hemis)
+               END DO
+               zht_i_ini(i_fill,i_hemis) = ( zvt_i_ini(i_hemis) - zV ) / za_i_ini(i_fill,i_hemis) 
+               IF ( i_fill .LT. jpl ) zht_i_ini(i_fill+1:jpl, i_hemis) = 0._wp
+
+            !--- volumes
+               zv_i_ini(:,i_hemis) = za_i_ini(:,i_hemis) * zht_i_ini(:,i_hemis)
+               IF ( i_fill .LT. jpl ) zv_i_ini(i_fill+1:jpl, i_hemis) = 0._wp
+
+            ENDIF ! i_fill
+
+            !---------------------
+            ! Compatibility tests
+            !---------------------
+            ! Test 1: area conservation
+            zA_cons = SUM(za_i_ini(:,i_hemis)) ; zconv = ABS(zat_i_ini(i_hemis) - zA_cons )
+            IF ( zconv .LT. 1.0e-6 ) THEN
+               ztest_1 = 1
+            ELSE 
+              ! this write is useful
+              IF(lwp)  WRITE(numout,*) ' * TEST1 AREA NOT CONSERVED *** zA_cons = ', zA_cons,' zat_i_ini = ',zat_i_ini(i_hemis) 
+               ztest_1 = 0
+            ENDIF
+
+            ! Test 2: volume conservation
+            zV_cons = SUM(zv_i_ini(:,i_hemis))
+            zconv = ABS(zvt_i_ini(i_hemis) - zV_cons)
+
+            IF ( zconv .LT. 1.0e-6 ) THEN
+               ztest_2 = 1
+            ELSE
+              ! this write is useful
+              IF(lwp)  WRITE(numout,*) ' * TEST2 VOLUME NOT CONSERVED *** zV_cons = ', zV_cons, &
+                            ' zvt_i_ini = ', zvt_i_ini(i_hemis)
+               ztest_2 = 0
+            ENDIF
+
+            ! Test 3: thickness of the last category is in-bounds ?
+            IF ( zht_i_ini(i_fill, i_hemis) .GT. hi_max(i_fill-1) ) THEN
+               ztest_3 = 1
+            ELSE
+               ! this write is useful
+               IF(lwp) WRITE(numout,*) ' * TEST 3 THICKNESS OF THE LAST CATEGORY OUT OF BOUNDS *** zht_i_ini(i_fill,i_hemis) = ', &
+               zht_i_ini(i_fill,i_hemis), ' hi_max(jpl-1) = ', hi_max(i_fill-1)
+               ztest_3 = 0
+            ENDIF
+
+            ! Test 4: positivity of ice concentrations
+            ztest_4 = 1
+            DO jl = 1, jpl
+               IF ( za_i_ini(jl,i_hemis) .LT. 0._wp ) THEN 
+                  ! this write is useful
+                  IF(lwp) WRITE(numout,*) ' * TEST 4 POSITIVITY NOT OK FOR CAT ', jl, ' WITH A = ', za_i_ini(jl,i_hemis)
+                  ztest_4 = 0
+               ENDIF
+            END DO
+
+         ENDIF ! ztest_1 + ztest_2 + ztest_3 + ztest_4
+ 
+         ztests = ztest_1 + ztest_2 + ztest_3 + ztest_4
+
+      END DO ! i_fill
+
+      IF(lwp) THEN 
+         WRITE(numout,*), ' ztests : ', ztests
+         IF ( ztests .NE. 4 ) THEN
+            WRITE(numout,*)
+            WRITE(numout,*), ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
+            WRITE(numout,*), ' !!!! RED ALERT                  !!! '
+            WRITE(numout,*), ' !!!! BIIIIP BIIIP BIIIIP BIIIIP !!!'
+            WRITE(numout,*), ' !!!! Something is wrong in the LIM3 initialization procedure '
+            WRITE(numout,*), ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
+            WRITE(numout,*)
+            WRITE(numout,*), ' *** ztests is not equal to 4 '
+            WRITE(numout,*), ' *** ztest_i (i=1,4) = ', ztest_1, ztest_2, ztest_3, ztest_4
+            WRITE(numout,*), ' zat_i_ini : ', zat_i_ini(i_hemis)
+            WRITE(numout,*), ' zhm_i_ini : ', zhm_i_ini(i_hemis)
+         ENDIF ! ztests .NE. 4
+      ENDIF
+      
+      END DO ! i_hemis
+
+      !---------------------------------------------------------------------
+      ! 3.3) Space-dependent arrays for ice state variables
+      !---------------------------------------------------------------------
+
+      ! Ice concentration, thickness and volume, snow depth, ice
+      ! salinity, ice age, surface temperature
+      DO jl = 1, jpl ! loop over categories
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               a_i(ji,jj,jl)   = zidto(ji,jj) * za_i_ini (jl,zhemis(ji,jj))  ! concentration
+               ht_i(ji,jj,jl)  = zidto(ji,jj) * zht_i_ini(jl,zhemis(ji,jj))  ! ice thickness
+               ht_s(ji,jj,jl)  = zidto(ji,jj) * zhm_s_ini(zhemis(ji,jj))     ! snow depth
+               sm_i(ji,jj,jl)  = zidto(ji,jj) * zsm_i_ini(zhemis(ji,jj))     ! salinity
+               o_i(ji,jj,jl)   = zidto(ji,jj) * 1._wp + ( 1._wp - zidto(ji,jj) ) ! age
+               t_su(ji,jj,jl)  = zidto(ji,jj) * 270.0 + ( 1._wp - zidto(ji,jj) ) * t_bo(ji,jj) ! surf temp
+ 
+               ! ice volume, snow volume, salt content, age content
+               v_i(ji,jj,jl)   = ht_i(ji,jj,jl) * a_i(ji,jj,jl)              ! ice volume
+               v_s(ji,jj,jl)   = ht_s(ji,jj,jl) * a_i(ji,jj,jl)              ! snow volume
+               smv_i(ji,jj,jl) = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl) ! salt content
+               oa_i(ji,jj,jl)  = o_i(ji,jj,jl) * a_i(ji,jj,jl)               ! age content
+            END DO ! ji
+         END DO ! jj
+      END DO ! jl
+
+      ! Snow temperature and heat content
+      DO jk = 1, nlay_s
+         DO jl = 1, jpl ! loop over categories
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                   t_s(ji,jj,jk,jl) = zidto(ji,jj) * 270.0 + ( 1._wp - zidto(ji,jj) ) * rtt
+                   ! Snow energy of melting
+                   e_s(ji,jj,jk,jl) = zidto(ji,jj) * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
+                   ! Change dimensions
+                   e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
+                   ! Multiply by volume, so that heat content in 10^9 Joules
+                   e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * v_s(ji,jj,jl) / nlay_s
+               END DO ! ji
+            END DO ! jj
+         END DO ! jl
+      END DO ! jk
+
+      ! Ice salinity, temperature and heat content
+      DO jk = 1, nlay_i
+         DO jl = 1, jpl ! loop over categories
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                   t_i(ji,jj,jk,jl) = zidto(ji,jj) * 270.00 + ( 1._wp - zidto(ji,jj) ) * rtt 
+                   s_i(ji,jj,jk,jl) = zidto(ji,jj) * zsm_i_ini(zhemis(ji,jj)) + ( 1._wp - zidto(ji,jj) ) * s_i_min
+                   ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
+
+                   ! heat content per unit volume
+                   e_i(ji,jj,jk,jl) = zidto(ji,jj) * rhoic * (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
+                      +   lfus    * ( 1._wp - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-epsi20) ) &
+                      -   rcp     * ( ztmelts - rtt ) )
+
+                   ! Correct dimensions to avoid big values
+                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
+
+                   ! Mutliply by ice volume, and divide by number of layers 
+                   ! to get heat content in 10^9 J
+                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * area(ji,jj) * v_i(ji,jj,jl) / nlay_i
+               END DO ! ji
+            END DO ! jj
+         END DO ! jl
+      END DO ! jk
+
+      !--------------------------------------------------------------------
+      ! 4) Global ice variables for output diagnostics                    | 
+      !--------------------------------------------------------------------
+      fsbbq (:,:)     = 0._wp
+      u_ice (:,:)     = 0._wp
+      v_ice (:,:)     = 0._wp
+      stress1_i(:,:)  = 0._wp
+      stress2_i(:,:)  = 0._wp
+      stress12_i(:,:) = 0._wp
+
+# if defined key_coupled
+      albege(:,:)   = 0.8 * tms(:,:)
+# endif
+
+      !--------------------------------------------------------------------
+      ! 5) Moments for advection
+      !--------------------------------------------------------------------
+
+      sxopw (:,:) = 0._wp 
+      syopw (:,:) = 0._wp 
+      sxxopw(:,:) = 0._wp 
+      syyopw(:,:) = 0._wp 
+      sxyopw(:,:) = 0._wp
+
+      sxice (:,:,:)  = 0._wp   ;   sxsn (:,:,:)  = 0._wp   ;   sxa  (:,:,:)  = 0._wp
+      syice (:,:,:)  = 0._wp   ;   sysn (:,:,:)  = 0._wp   ;   sya  (:,:,:)  = 0._wp
+      sxxice(:,:,:)  = 0._wp   ;   sxxsn(:,:,:)  = 0._wp   ;   sxxa (:,:,:)  = 0._wp
+      syyice(:,:,:)  = 0._wp   ;   syysn(:,:,:)  = 0._wp   ;   syya (:,:,:)  = 0._wp
+      sxyice(:,:,:)  = 0._wp   ;   sxysn(:,:,:)  = 0._wp   ;   sxya (:,:,:)  = 0._wp
+
+      sxc0  (:,:,:)  = 0._wp   ;   sxe  (:,:,:,:)= 0._wp   
+      syc0  (:,:,:)  = 0._wp   ;   sye  (:,:,:,:)= 0._wp   
+      sxxc0 (:,:,:)  = 0._wp   ;   sxxe (:,:,:,:)= 0._wp   
+      syyc0 (:,:,:)  = 0._wp   ;   syye (:,:,:,:)= 0._wp   
+      sxyc0 (:,:,:)  = 0._wp   ;   sxye (:,:,:,:)= 0._wp   
+
+      sxsal  (:,:,:)  = 0._wp
+      sysal  (:,:,:)  = 0._wp
+      sxxsal (:,:,:)  = 0._wp
+      syysal (:,:,:)  = 0._wp
+      sxysal (:,:,:)  = 0._wp
+
+      !--------------------------------------------------------------------
+      ! 6) Lateral boundary conditions                                    | 
       !--------------------------------------------------------------------
 
       DO jl = 1, jpl
+
          CALL lbc_lnk( a_i(:,:,jl)  , 'T', 1. )
          CALL lbc_lnk( v_i(:,:,jl)  , 'T', 1. )
